include:
- remote: 'https://gitlab.com/hq-smarthome/home-lab/job-template/-/raw/main/.gitlab-ci.yml'

variables:
  DOCKER_HOST: tcp://docker:2376
  DOCKER_TLS_CERTDIR: "/certs"
  DOCKER_SERVICE: "docker:stable"
  DOCKER_IMAGE_NAME: $CI_REGISTRY/$CI_PROJECT_NAMESPACE/$CI_PROJECT_NAME/hq-shelly-monitor

docker-build:
  stage: build
  tags:
  - docker
  image: $DOCKER_SERVICE
  services:
    - $DOCKER_SERVICE-dind
  before_script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - docker pull $DOCKER_IMAGE_NAME:latest || true
  script:
    - docker build --cache-from $DOCKER_IMAGE_NAME:latest --tag $DOCKER_IMAGE_NAME:latest --tag $DOCKER_IMAGE_NAME:$CI_COMMIT_SHA .
    - docker push $DOCKER_IMAGE_NAME:latest
    - docker push $DOCKER_IMAGE_NAME:$CI_COMMIT_SHA

nomad-render:
  before_script:
  - 'echo "monitorImage: $DOCKER_IMAGE_NAME:$CI_COMMIT_SHA" >> "$LEVANT_VAR_FILE"'

nomad-deploy:
  needs:
  - job: nomad-render
    artifacts: true
  - job: nomad-validate
  - job: nomad-plan
    artifacts: true
  - job: terraform-apply
    artifacts: false
    optional: true
  - job: docker-build
    optional: true
